/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.controllers;

import java.util.Iterator;

import kumbang.core.model.constraint.AttributeReference;
import kumbang.core.model.type.AttributeDefinition;
import kumbang.core.model.type.ComposableType;
import kumbang.core.model.type.FeatureType;
import kumbang.modeller.ui.properties.AttributeDefinitionPropertySource;

import org.eclipse.ui.views.properties.IPropertySource;

public class AttributeDefinitionController extends BasicController {

	private AttributeDefinition definition;

	private ComposableTypeController parent;

	public AttributeDefinitionController(ModelController modelController, AttributeDefinition def) {
		super(modelController);
		this.definition = def;
	
	}
	


	public Object[] getChildren() {
		return new Object[0];
//		AttributeValueTypeController controller = (AttributeValueTypeController) modelController.getControllerFactory().createController(definition.getType());
//		controller.setDefinition(definition);
//		controller.setSuperType(parent.getComposableType());
//		return new Object[] {controller};
	}

	public boolean hasChildren() {
		return false;
	}
	
	

	public String getName() {
		return definition.getName();
	}

	public int getType() {
		return ATTRIBUTE_DEFINITION;
	}

	public Object getAdapter(Class adapter) {
		if (adapter == IPropertySource.class) {
			if (propertySource == null)
				propertySource = new AttributeDefinitionPropertySource(this, modelController);
			return propertySource;
		}
		return null;
	}

	public void setName(String name) {
		if (definition.getName().equals(name))
			return;

//		for (Iterator<AttributeReference> i = type.getAttributeReferences(); i.hasNext();) {
//			AttributeReference current = i.next();
//			if (current.getName().equals(definition.getName()))
//				current.setName(name);
//				
//			
//		}
	
			
		definition.setName(name);
		
		
		modified();
		
	}

	public String getImageString() {
		return BasicController.ATTRIBUTE_DEFINITION_IMAGE_STRING;
	}

	public void delete() {
		parent.removeAttributeDefinition(definition.getName());
		modified();
	}

	public String getBackgroundString() {
		// TODO Auto-generated method stub
		return ATTRIBUTE_DEFINITION_COLOR_STRING;
	}

	public String getAttributeName() {
		return definition.getType().getName();
	}

	public void setTypes(String type) {
		if (getAttributeName().equals(type))
			return;
		definition.setType(modelController.getAttributeType(type));
		modified();
		
	}


	public String getDisplayName() {
		
		return definition.getDisplayName();

	}

	public void setDisplayName(String text) {
		definition.setDisplayName(text);
	}

	@Override
	public String getDisplayText() {
		return definition.getType().getName() + " " + definition.getName();
	}

	public String getParentName() {
		return parent.getName();
	}

	public int getParentType() {
		return parent.getType();
	}

	public void setParent(ComposableTypeController controller) {
		this.parent = controller;
		
	}


}
