/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.controllers;

import kumbang.modeller.ui.event.ModelChangeEvent;
import kumbang.modeller.ui.properties.AttributeDefinitionPropertySource;
import kumbang.modeller.ui.properties.BasicPropertySource;
import kumbang.modeller.util.Constants;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.ui.views.properties.IPropertySheetPage;
import org.eclipse.ui.views.properties.PropertySheetPage;
import org.eclipse.ui.views.properties.PropertySheetSorter;
import org.eclipse.ui.views.properties.tabbed.TabbedPropertySheetPage;


public abstract class BasicController implements IAdaptable, Constants {

	protected ModelController modelController;
	protected BasicPropertySource propertySource;
	
	public BasicController(ModelController modelController) {
		this.modelController = modelController;
	}
	
	public abstract String getName();
	 
	public abstract Object[] getChildren();

	public abstract boolean hasChildren();
	
	public abstract int getType();

	public abstract String getDisplayText();
	
	public abstract String getImageString();
		
	public void modified() {
		if (propertySource != null)
			propertySource.modified();
		modelController.modified(new ModelChangeEvent());
	}
	
	public void modified(boolean isUndo) {
		modelController.modified(new ModelChangeEvent(isUndo));
	}

	public abstract void delete();

	public abstract String getBackgroundString() ;

	public abstract String getDisplayName();


	
}
