/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.controllers;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import kumbang.core.model.type.ComponentType;
import kumbang.core.model.type.Connection;

public class ConnectionGroupController extends BasicController {

	private ComponentType type;

	public ConnectionGroupController(ModelController modelController, ComponentType type) {
		super(modelController);
		this.type = type;
	}

	@Override
	public void delete() {
		// TODO Auto-generated method stub

	}

	@Override
	public String getBackgroundString() {
		return CONNECTION_COLOR_STRING;
	}

	@Override
	public Object[] getChildren() {
		Iterator<Connection> connections= type.getConnections();
		List<BasicController> controllers = new LinkedList<BasicController>();
		ComponentTypeController parent = (ComponentTypeController) modelController.getControllerFactory().createController(type);
		
		while (connections.hasNext()) {
			ConnectionController cc = (ConnectionController)modelController.getControllerFactory().createController(connections.next());
			cc.setParent(parent);
			controllers.add(cc);
		
		}
		return controllers.toArray();
	}

	@Override
	public String getDisplayName() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getDisplayText() {
		return getName();
	}

	@Override
	public String getImageString() {
		return CONNECTION_IMAGE_STRING;
	}

	@Override
	public String getName() {
		return "connections";
	}

	@Override
	public int getType() {
		return CONNECTION_GROUP;
	}

	@Override
	public boolean hasChildren() {
		return true;
	}

	public Object getAdapter(Class adapter) {
		// TODO Auto-generated method stub
		return null;
	}
	public ComposableTypeController getParentController() {
		return (ComposableTypeController) modelController.getControllerFactory().createController(type);
	}

}
