/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.controllers;

import java.util.Iterator;

import kumbang.core.model.constraint.BooleanExpression;
import kumbang.core.model.type.ComposableType;

public class ConstraintGroupController extends BasicController {

	private ComposableType type;

	public ConstraintGroupController(ModelController modelController, ComposableType type) {
		super(modelController);
		this.type = type;
	}

	@Override
	public void delete() {
		// TODO Auto-generated method stub

	}

	@Override
	public String getBackgroundString() {
		return CONSTRAINT_IMAGE_STRING;
	}

	@Override
	public Object[] getChildren() {
		Object[] constraints = type.getConstraintsArray();
		ComposableTypeController parent = (ComposableTypeController) modelController.getControllerFactory().createController(type);
		ConstraintController[] controllers = new ConstraintController[constraints.length];
		for (int i = 0; i < controllers.length; i++) {
			controllers[i] = (ConstraintController)modelController.getControllerFactory().createController(constraints[i]);
			controllers[i].setParent(parent);
		}
		return controllers;
	}

	@Override
	public String getDisplayName() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getDisplayText() {
		return "constraints";
	}

	@Override
	public String getImageString() {
		return CONSTRAINT_IMAGE_STRING;
	}

	@Override
	public String getName() {
		return "constraints";
	}

	@Override
	public int getType() {
		return CONSTRAINT_GROUP;
	}

	@Override
	public boolean hasChildren() {
		return true;
	}

	public Object getAdapter(Class adapter) {
		return null;
	}

	public ComposableTypeController getParentController() {
		return (ComposableTypeController) modelController.getControllerFactory().createController(type);
	}

	public Iterator<BooleanExpression> getConstraints() {
		return type.getConstraints();
	}

}
