/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.ui.dialogs;

import kumbang.modeller.controllers.ModelController;
import kumbang.modeller.ui.editor.operations.SetFeatureRootOperation;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.operations.IUndoContext;
import org.eclipse.core.commands.operations.UndoContext;
import org.eclipse.core.runtime.Status;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Shell;

public class SelectFeatureRootDialog extends UndoableOperationDialog {

	private List features;
	private ModelController modelController;
	
	protected Control createDialogArea(Composite parent) {
		Composite composite = new Composite(parent, SWT.NULL);	
		composite.setLayout(new GridLayout());
		composite.setLayoutData(LayoutFactory.getInstance().getFillGridData());
		
		features = new List(composite, SWT.BORDER | SWT.SINGLE);
		;
		features.setLayoutData(LayoutFactory.getInstance().getFillGridData());
		
		features.setItems(modelController.getFeatureTypes());
		
		features.addSelectionListener(new SelectionListener() {

			public void widgetSelected(SelectionEvent e) {
				updateStatus(Status.OK_STATUS);
				
			}

			public void widgetDefaultSelected(SelectionEvent e) {
				// TODO Auto-generated method stub
				
			}});
		
		return composite;
	}
	
	
	public SelectFeatureRootDialog(Shell shell, IUndoContext undoContext, ModelController controller) {
		super(shell, undoContext, "Select Feature Root");
		this.modelController = controller;


	}

	protected void checkStatus() {
		if (features.getSelectionCount() == 1)
			updateStatus(Status.OK_STATUS);
		else updateStatus(status);
			
	}


	protected void updateInfo() {
		// TODO Auto-generated method stub
		
	}


	protected void doNew() throws ExecutionException {
		String[] selected = features.getSelection();
    	if (selected != null && selected.length > 0)
    		doOperation(new SetFeatureRootOperation(modelController, selected[0]));
		
		
	}


	protected boolean isPropertyDialog() {
		// TODO Auto-generated method stub
		return false;
	}
}
