/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.ui.dialogs.constraints;

import kumbang.modeller.controllers.ComposableTypeController;
import kumbang.modeller.controllers.ModelController;
import kumbang.modeller.ui.dialogs.ModifiableStatusDialog;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;

public abstract class ConstraintExpressionDialog extends ModifiableStatusDialog {


	protected ComposableTypeController controller;
	protected ConstraintDialog dialog;
	protected boolean isImplementation;
	protected ModelController modelController;
	protected boolean update = false;

	protected ConstraintExpressionDialog(ConstraintDialog dialog, ComposableTypeController controller, Shell parentShell, boolean isImplementation, ModelController modelController) {
		super(parentShell);
		this.dialog = dialog;
		this.controller = controller;
		this.isImplementation = isImplementation;	
		this.modelController = modelController;
	}
	
	protected ConstraintExpressionDialog(ConstraintDialog dialog, ComposableTypeController controller, Shell parentShell, boolean isImplementation, ModelController modelController, String name) {
		super(parentShell);
		this.dialog = dialog;
		this.controller = controller;
		this.isImplementation = isImplementation;	
		this.modelController = modelController;
		setTitle(name);
	}
	

	public abstract Control createDialogArea(Composite parent);
	protected abstract void setExpression();

}
