/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.ui.dialogs.constraints;

import java.util.ArrayList;
import java.util.Iterator;

import javax.swing.text.html.HTMLDocument.HTMLReader.IsindexAction;

import kumbang.core.model.constraint.BooleanExpression;
import kumbang.modeller.controllers.ConstraintGroupController;
import kumbang.modeller.controllers.FeatureTypeController;
import kumbang.modeller.ui.dialogs.ModifiableStatusDialog;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Shell;

public class ConstraintsGroupDialog extends ModifiableStatusDialog {

	private ConstraintGroupController controller;
	private List constraints;
	private ArrayList<BooleanExpression> constraintsList = new ArrayList<BooleanExpression>();

	public ConstraintsGroupDialog(Shell parent, ConstraintGroupController controller) {
		super(parent);
		this.controller = controller;
	}
	
	public Control createDialogArea(Composite parent) {
		Composite composite = new Composite(parent, SWT.NULL);
		
		constraints = new List(composite, SWT.H_SCROLL | SWT.V_SCROLL | SWT.BORDER);
		for (Iterator<BooleanExpression> it = controller.getConstraints(); it.hasNext();) {
			BooleanExpression be = it.next();
			constraints.add(be.getModelString(controller.getParentController() instanceof FeatureTypeController ? true : false));
			constraintsList.add(be);
		}
		return composite;
	}

	

}
