/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.ui.dnd;

import kumbang.modeller.controllers.BasicController;
import kumbang.modeller.ui.properties.NamePropertySource;
import kumbang.modeller.ui.viewers.KumbangTreeViewer;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.DragSourceEvent;
import org.eclipse.swt.dnd.DragSourceListener;

public class TypeViewDragSourceListener implements DragSourceListener {

	private Viewer viewer;
	
	
	public TypeViewDragSourceListener(Viewer viewer) {
		this.viewer = viewer;
	}
	
	public void dragStart(DragSourceEvent event) {
		event.doit = !viewer.getSelection().isEmpty() && ((StructuredSelection)viewer.getSelection()).getFirstElement() instanceof BasicController;
		event.detail = DND.DROP_COPY;
	}

	public void dragSetData(DragSourceEvent event) {
		
		ISelection selection = viewer.getSelection();
		if (selection instanceof StructuredSelection) {
			BasicController element = (BasicController)((StructuredSelection)selection).getFirstElement();
			event.data = new TypeTransferData(element.getName(), element.getType());
		}
		
	}

	public void dragFinished(DragSourceEvent event) {
		 viewer.refresh();		
	}

}
