/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.ui.editor;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IStorage;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IPath;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IFileEditorInput;
import org.eclipse.ui.IPersistableElement;

public class KumbangEditorInput implements IFileEditorInput {

	private String name;
	private IFileEditorInput input;
	private String type;


	public KumbangEditorInput(String name, String type, IFileEditorInput input) {
		this.name = name;
		this.input = input;
		this.type = type;
	}
	
	public boolean exists() {
		return false;
	}

	public ImageDescriptor getImageDescriptor() {
		 return input.getImageDescriptor();
	}

	public String getName() {
		return name;
	}

	public IPersistableElement getPersistable() {
		return input.getPersistable();
	}

	public String getToolTipText() {
		return name;
	}

	public Object getAdapter(Class adapter) {
		return input.getAdapter(adapter);
	}

	public IFile getFile() {
		return input.getFile();
	}

	public IStorage getStorage() throws CoreException {
		return input.getStorage();
	}

	public String getType() {
		return type;
	}

}
