/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.ui.perspective;

import kumbang.modeller.KumbangModellerPlugin;

import org.eclipse.core.runtime.Plugin;
import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;
import org.eclipse.ui.part.ViewPart;

public class KumbangModellerPerspective implements IPerspectiveFactory {

	public void createInitialLayout(IPageLayout layout) {
	
		String editorArea = layout.getEditorArea();
		
		IFolderLayout properties;
		IFolderLayout bottomLeft;
		IFolderLayout bottomCenter;
		IFolderLayout bottomRight;
		IFolderLayout left;
		
		
		left = layout.createFolder("left", IPageLayout.LEFT, 0.22f, editorArea);
		left.addView(IPageLayout.ID_RES_NAV);
	
		properties = layout.createFolder("properties", IPageLayout.BOTTOM, 0.75f, "left");
		properties.addView(IPageLayout.ID_PROP_SHEET);
		
		bottomCenter = layout.createFolder("bottomCenter", IPageLayout.BOTTOM, 0.15f, editorArea);
		bottomCenter.addView(KumbangModellerPlugin.FEATURE_VIEW_ID);
	
		bottomLeft = layout.createFolder("bottomLeft", IPageLayout.LEFT, 0.33f, "bottomCenter");
		bottomLeft.addView(KumbangModellerPlugin.TYPE_VIEW_ID);
		
		bottomRight = layout.createFolder("bottomRight", IPageLayout.RIGHT, 0.50f, "bottomCenter");
		bottomRight.addView(KumbangModellerPlugin.COMPONENT_VIEW_ID);
		
	
	}

}
