/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.ui.preferences;

import kumbang.modeller.KumbangModellerPlugin;

import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

public class PreferencePage extends FieldEditorPreferencePage implements IWorkbenchPreferencePage {
        
	public static final String SIMPLE_VIEW = "simpleView";
	private BooleanFieldEditor simpleView;

	public PreferencePage() {
		super(GRID);
		setPreferenceStore(KumbangModellerPlugin.getDefault().getPreferenceStore());
	}
	
	public void createFieldEditors() {                 
		
		simpleView = new BooleanFieldEditor(SIMPLE_VIEW, "Use simple view (definitions are combined with features or components where possible)", getFieldEditorParent());
		addField(simpleView);
		
		this.adjustGridLayout();
		
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	public void init(IWorkbench workbench) {
	}

	
}
