/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.ui.properties;

import java.util.LinkedList;
import java.util.List;

import kumbang.modeller.controllers.ModelController;

import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertySource;
import org.eclipse.ui.views.properties.IPropertySource2;
import org.eclipse.ui.views.properties.PropertyDescriptor;

public abstract class BasicPropertySource implements IPropertyNames, IPropertySource {

	protected List<PropertyDescriptor> propertyDescriptors = new LinkedList<PropertyDescriptor>();
	protected ModelController modelController;
	private IPropertyDescriptor[] propertyArray;
	
	
	 
	 public BasicPropertySource(ModelController modelController) {
		 this.modelController = modelController;
	 }
	 
	 public IPropertyDescriptor[] getPropertyDescriptors() {
			
			if (propertyDescriptors.size() == 0) {
				createDescriptors();
				propertyArray = new IPropertyDescriptor[propertyDescriptors.size()];
				for (int i = 0; i < propertyArray.length; i++)
					propertyArray[i] = propertyDescriptors.get(i);
			}
			
			return propertyArray;

		 }

	protected abstract void createDescriptors();
	
	public void modified() {
		propertyDescriptors.clear();

	}
	
	public boolean isPropertySet(Object id) {
		return false;
	}
}
