/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.ui.properties;

import org.eclipse.ui.views.properties.TextPropertyDescriptor;

import kumbang.core.model.type.Connection;
import kumbang.modeller.controllers.ConnectionController;
import kumbang.modeller.controllers.ModelController;

public class ConnectionPropertySource extends BasicPropertySource {

	private ConnectionController connection;
	private String PROPERTY_CONNECTION_FROM ="kumbang.property.connection_from";
	private String PROPERTY_CONNECTION_TO ="kumbang.property.connection_to";

	public ConnectionPropertySource(ConnectionController connection, ModelController modelController) {	
		super(modelController);
		this.connection = connection;
	}


	public Object getEditableValue() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean isPropertySet(Object id) {
		// TODO Auto-generated method stub
		return false;
	}

	public void resetPropertyValue(Object id) {
		// TODO Auto-generated method stub

	}

	public void setPropertyValue(Object id, Object value) {
	

	}
	
	protected String getName() {
		return connection.getName();
	}


	@Override
	protected void createDescriptors() {
		propertyDescriptors.add(new TextPropertyDescriptor(PROPERTY_CONNECTION_FROM, "Source"));
		propertyDescriptors.add(new TextPropertyDescriptor(PROPERTY_CONNECTION_TO, "Target"));
	}


	public Object getPropertyValue(Object id) {
		if (id == PROPERTY_CONNECTION_FROM)
			return connection.getSourceString();
		if (id == PROPERTY_CONNECTION_TO)
			return connection.getTargetString();
		
		return null;
	}


	public boolean isPropertyResettable(Object id) {
		return false;
	}

}
