/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.ui.properties;

import kumbang.modeller.controllers.ModelController;

import org.eclipse.ui.views.properties.TextPropertyDescriptor;

public abstract class NamePropertySource extends BasicPropertySource {
 
	 private static final String CATEGORY_BASIC = "Basic";

	public NamePropertySource(ModelController modelController) {
		super(modelController);
		
	}

	protected void createDescriptors() {
		
		 TextPropertyDescriptor nameDescriptor = new TextPropertyDescriptor(PROPERTY_NAME,"Name");
		// TextPropertyDescriptor commentDescriptor =new TextPropertyDescriptor(PROPERTY_COMMENT,"Comment");
//		 nameDescriptor.setCategory(CATEGORY_BASIC);
//		 commentDescriptor.setCategory(CATEGORY_BASIC);
		 propertyDescriptors.add(nameDescriptor);
		// propertyDescriptors.add(commentDescriptor);
	     
     
	 }
	 
	 public void setPropertyValue(Object id, Object value) {
		 if (id == PROPERTY_NAME && value instanceof String)
				setName((String)value);
		 
		 if (id == PROPERTY_COMMENT && value instanceof String)
				setDisplayName((String)value);
	 }
	 
	public Object getPropertyValue(Object id) {
		 if (id == PROPERTY_NAME)
			 return getName();
		 
		 return null;
	 }
	 protected abstract String getName();
	 
	 protected abstract void setName(String name);
	 
	 protected abstract String getDisplayName();
	 
	 protected abstract void setDisplayName(String displayName);
	 
	 
}
