/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.ui.viewers;

import kumbang.core.model.core.FeaturedModel;
import kumbang.modeller.controllers.ControllerFactory;
import kumbang.modeller.controllers.ModelController;
import kumbang.modeller.ui.properties.FeatureTypePropertySource;

public class FeatureContentProvider extends StructureContentProvider {


	public FeatureContentProvider(ControllerFactory controllerFactory) {
		super(controllerFactory);
	
	}

	public Object[] getElements(Object inputElement) {
		if (!(inputElement instanceof FeaturedModel))
			return new Object[0];
		
		FeaturedModel model = (FeaturedModel)inputElement;
		
		if (model.getFeatureRoot() != null)
			return new Object[] {controllerFactory.createController(model.getFeatureRoot())};
		
		return new Object[0];
	}

}
