/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.ui.viewers;



import kumbang.modeller.controllers.BasicController;
import kumbang.modeller.controllers.ControllerFactory;
import kumbang.modeller.controllers.ModelController;

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

public abstract class StructureContentProvider implements ITreeContentProvider {

	

	protected ControllerFactory controllerFactory;

	public StructureContentProvider(ControllerFactory controllerFactory) {
		this.controllerFactory = controllerFactory;
	}
	
	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof BasicController)
			return ((BasicController)parentElement).getChildren();
		throw new IllegalArgumentException("Cannot resolve children of " + parentElement);
	}



	public Object getParent(Object element) {
		return null;
	}

	public boolean hasChildren(Object element) {

		if (element != null && element instanceof BasicController)
			return ((BasicController)element).hasChildren();
		return false;
	}


	
	
	public void dispose() {
		// TODO Auto-generated method stub

	}

	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		// TODO Auto-generated method stub

	}

}
