/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.ui.viewers;

import kumbang.modeller.controllers.ModelController;
import kumbang.modeller.util.Constants;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

public class TypeContentProvider implements IStructuredContentProvider, ITreeContentProvider, Constants {

	private int type;
	
	public TypeContentProvider(int type) {
		this.type = type;
	}
	
	public Object[] getElements(Object inputElement) {
		if (inputElement instanceof ModelController) {
			switch (type) {
			
			case FEATURE_TYPE:
				return ((ModelController)inputElement).getFeatureTypeControllers();
				
			case COMPONENT_TYPE:
				return ((ModelController)inputElement).getComponentTypeControllers();
			
			case INTERFACE_TYPE:
				return ((ModelController)inputElement).getInterfaceTypeControllers();
			
			case ATTRIBUTE_VALUE_TYPE:
				return ((ModelController)inputElement).getAttributeTypeControllers();	
			}
			
		}
		
		return new Object[0];
		
		
	}
	public void dispose() {
		// TODO Auto-generated method stub
		
	}
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		// TODO Auto-generated method stub
		
	}

	public Object[] getChildren(Object parentElement) {
		// TODO Auto-generated method stub
		return null;
	}

	public Object getParent(Object element) {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean hasChildren(Object element) {
		// TODO Auto-generated method stub
		return false;
	}

}
