/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.ui.views;

import kumbang.modeller.ui.editor.KumbangModellerEditor;
import kumbang.modeller.ui.event.ModelChangeEvent;
import kumbang.modeller.ui.event.ModellerEvent;
import kumbang.modeller.ui.viewers.KumbangTreeViewer;

import org.eclipse.swt.widgets.Control;

public abstract class KumbangTreeViewPage extends KumbangViewPage {

	protected KumbangTreeViewer treeViewer;
	
	public KumbangTreeViewPage(KumbangModellerEditor editor) {
		super(editor);
	
	}


	public Control getControl() {
		if (treeViewer != null)
			return treeViewer.getControl();
		return null;
	}

	public void setFocus() {
		treeViewer.getControl().setFocus();
		
	}


}
