/*
This file is part of KumbangTools

    KumbangTools is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KumbangTools is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KumbangTools; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


package kumbang.modeller.ui.views;

import kumbang.modeller.ui.editor.KumbangModellerEditor;
import kumbang.modeller.ui.event.ModelChangeEvent;
import kumbang.modeller.ui.event.ModelChangeListener;
import kumbang.modeller.ui.event.ModellerEvent;
import kumbang.modeller.ui.viewers.TypeViewer;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

public class TypeViewPage extends KumbangViewPage {


	private TypeViewer viewer;
	
	


	public TypeViewPage(KumbangModellerEditor editor) {
		super(editor);
	
	}



	public void createControl(Composite parent) {
		viewer = new TypeViewer(editor.getToolkit(), parent, editor.getUndoContext(), editor.getModelController(), editor.getActionFactory(), editor.getLabelProvider());
		getSite().setSelectionProvider(viewer.getSelectionProvider());
	}



	
	public Control getControl() {
		if (viewer != null)
			return viewer.getControl();
		return null;
	}


	public void setFocus() {
		viewer.getControl().setFocus();
	}



	public void modelChanged(ModellerEvent event) {
		viewer.refresh();
				
	}
	


}
